package adaption;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import cases.Case;
import features.SolverTimesFeature;

public class AdaptToSchedule extends AdaptationAgent{

	@Override
	public SolverScheduleSolution adaptCases(List<Case> theCases,
			HashMap<Case, Double> similarities, Case query) {
		// TODO Auto-generated method stub
		System.err.println("c List of same ones: " + theCases.size());
		Iterator<Case> itr = theCases.iterator();
		while(itr.hasNext()){
			Case temp = itr.next();
			System.err.println("c " + temp.getCaseID());
			Iterator<String> featureNames = temp.featureNames();
			while(featureNames.hasNext()){
				String name = featureNames.next();
				if(!name.equals("Times")){
					System.err.printf("c " + name + " > %10f | ", ((Double)
							(temp.getFeature(name).getValue())).doubleValue());
				}
			}
			System.err.println("c");
			SolverTimesFeature ftr = 
				(SolverTimesFeature)
				temp.getFeature("Times");
			Iterator<String> solvers = ftr.getValue().keySet().iterator();
			while(solvers.hasNext()){
				String temp_solver = solvers.next();
				System.err.println("c " + temp_solver + 
						" : " + ftr.getValue().get(temp_solver));
			}
			System.err.println("c\nc");
		}
		SolverTimesFeature[] solver_times = new SolverTimesFeature[theCases.size()];
		double[] sims = new double[theCases.size()];
		for(int i = 0; i < solver_times.length; ++i){
			Case aCase = theCases.get(i);
			solver_times[i] = (SolverTimesFeature) aCase.getFeature("Times");
			sims[i] = similarities.get(aCase).doubleValue();
		}
		return new SolverScheduleSolution(
				new ThreeSolversSchedule(solver_times, sims).getSchedule());
	}
}
