package cases;

import java.util.ArrayList;
import java.util.List;

import features.FeatureStructure;



public class Casebase{
	
	private List<Case> casebase;
	
	
	private FeatureStructure[] caseStructure;
	
	private String casebaseName;
	
	public Casebase(String casebaseName, List<Case> cases, FeatureStructure[] caseStructure){
		casebase = cases;
		this.casebaseName = casebaseName;
		this.caseStructure = caseStructure;
	}
	

	public List<Case> getCases() {
		return casebase;
	}

	
	public void addCase(Case c) {
		casebase.add(c);
	}
	
	
	public void addCases(List<Case> cases) {
		casebase.addAll(cases);
	}

	
	public Case getCase(int index) {
		return casebase.get(index);
	}

	
	public boolean removeCases(List<Case> cases) {
		return casebase.removeAll(cases);
	}


	public boolean removeCase(Case c) {
		return casebase.remove(c);
	}

	
	public void clear() {
		casebase.clear();
	}

	
	public FeatureStructure[] getCaseStructure() {
		return caseStructure;
	}

	
	public int size() {
		return casebase.size();
	}
	
	public String getStemCasebaseName(){
		return casebaseName;
	}
	
	public void addFeatureStructure(FeatureStructure struct){
		FeatureStructure[] newCaseStructure = new FeatureStructure[caseStructure.length+1];
		for(int x=0;x<caseStructure.length;x++){
			newCaseStructure[x] = caseStructure[x];
		}
		newCaseStructure[caseStructure.length] = struct;
		caseStructure = newCaseStructure;
		System.out.println("The number of feature structures "+caseStructure.length);
	}
	
	public Object clone(){
		
		ArrayList<Case> cloneCases = new ArrayList<Case>();
		for(int x=0;x<this.size();x++){
			cloneCases.add((Case) getCase(x).clone());
		}
		FeatureStructure[] struct = new FeatureStructure[caseStructure.length];
		for(int x=0;x<struct.length;x++){
			struct[x]= (FeatureStructure) caseStructure[x].clone();
		}
		Casebase clone = new Casebase(this.getStemCasebaseName(), cloneCases, struct);
		return clone;
		
	}
	
	public void setFeatureStructure(FeatureStructure[] struct){
		caseStructure = struct;
	}
	
	public void setCases(List<Case> cases){
		casebase = cases;
	}

}
