package cases;

import features.BadFeatureValueException;
import features.DoubleFeature;
import parsers.Parser;


public class NormaliseCasebase{
	
	public static void normaliseCasebase(Casebase casebase, double[][] minMax){
		for(int x=0;x<casebase.size();x++){
			Case aCase =  casebase.getCase(x);
			for(int y=0; y<Parser.NUMBER_FEATURES;y++){
				double newValue =0.0;
				DoubleFeature feat = (DoubleFeature) aCase.getFeature(""+y);
				if(minMax[y][0] != minMax[y][1]){
					double oldValue = feat.getValue().doubleValue();
					newValue = (oldValue-minMax[y][0])/(minMax[y][1]- minMax[y][0]);
				}
				try {
					feat.setValue(new Double(newValue));
				} catch (BadFeatureValueException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

		
	}
	
	public static void normaliseCasebase(Casebase casebase, Casebase cb2){
		
		double[][] minMax = getMinMax(casebase);
		double[][] minMaxOther = getMinMax(cb2);
		for(int x=0;x<minMax.length;x++){
			if(minMax[x][0]>minMaxOther[x][0]){
				minMax[x][0] = minMaxOther[x][0];
			}
			if(minMax[x][1]<minMaxOther[x][1]){
				minMax[x][1] = minMaxOther[x][1];
			}
			
		}
		normaliseCasebase(casebase, minMax);
		normaliseCasebase(cb2, minMax);
	}
	
	public static double[][] getMinMax(Casebase casebase){
		
		double[][] minMax = new double[Parser.NUMBER_FEATURES][2];
		for(int x=0;x<casebase.size();x++){
			Case aCase =  casebase.getCase(x);
			for(int y=0; y<Parser.NUMBER_FEATURES;y++){
				DoubleFeature feat = (DoubleFeature) aCase.getFeature(""+y);
				double value = feat.getValue().doubleValue();
				if(value<minMax[y][0]){
					minMax[y][0] = value;
				}
				if(value>minMax[y][1]){
					minMax[y][1] = value;
				}
			}
			
		}
		return minMax;
	}	

}
