package evaluate;

import java.util.HashMap;
import java.util.Map;

import parsers.Parser;

import adaption.AdaptToSchedule;
import adaption.SolverScheduleSolution;
import adaption.ThreeWaySplitAdaptation;
import cases.Case;
import cases.CaseBasedReasoner;
import cases.Casebase;
import features.SolverTimesFeature;

public class EvaluateScheduler{
	
	public static boolean threeWaySplit = false;
	
	public static void runHoldOneOutEvaluation(Casebase casebase , int k){
		
		double numRight = 0;
		double numInstances = 0;
		ThreeWaySplitAdaptation adapt = new ThreeWaySplitAdaptation();
		for(int x =0;x<casebase.size();x++){
				Case query = casebase.getCase(x);
				//Case query = it.next();
				if(EvaluateReasoner.isValid((SolverTimesFeature)query.getFeature(Parser.SOLVER_TIMES_FEATURE))){
					casebase.getCases().remove(query);
					SolverScheduleSolution sol;
					if(!threeWaySplit ){
						CaseBasedReasoner cbr = new CaseBasedReasoner(new AdaptToSchedule(),k);
						cbr.buildReasoner(casebase);
						sol = (SolverScheduleSolution) cbr.classify(query);
					}else{
						sol =  (SolverScheduleSolution) adapt.adaptCases(null, null, null);
					}
					if(isSolved(query, sol)){
						numRight++;
					}
					numInstances++;
					//casebase.getCases().add(query);
					casebase.getCases().add(0, query);
				}
			
		}
		System.out.println("Percentage solved: "+(numRight/numInstances*100));
		double numExcluded =  (casebase.size()-numInstances);
		System.out.println("Number excluded "+numExcluded);
		System.out.println("The % exluded is "+(numExcluded/casebase.size()*100));	
	}
	
	public static void run_static_schecule(Casebase casebase){

		double numRight = 0;
		double numInstances = 0;
		ThreeWaySplitAdaptation adapt = new ThreeWaySplitAdaptation();
		SolverScheduleSolution sol;	
		CaseBasedReasoner cbr = new CaseBasedReasoner(new AdaptToSchedule(),casebase.size());
		cbr.buildReasoner(casebase);
		sol = (SolverScheduleSolution) cbr.classify(casebase.getCase(0));
		for(int x =0;x<casebase.size();x++){
				Case query = casebase.getCase(x);
				//Case query = it.next();
				if(EvaluateReasoner.isValid((SolverTimesFeature)query.getFeature(Parser.SOLVER_TIMES_FEATURE))){
//					casebase.getCases().remove(query);
//					if(!threeWaySplit ){
//						sol = (SolverScheduleSolution) cbr.classify(query);
//					}else{
//						sol =  (SolverScheduleSolution) adapt.adaptCases(null, null, null);
//					}
					if(isSolved(query, sol)){
						numRight++;
					}
					numInstances++;
					//casebase.getCases().add(query);
//					casebase.getCases().add(0, query);
				}
			
		}
		System.out.println("Percentage solved static: "+(numRight/numInstances*100));
		double numExcluded =  (casebase.size()-numInstances);
		System.out.println("Number excluded "+numExcluded);
		System.out.println("The % exluded is "+(numExcluded/casebase.size()*100));	
	}
	
	public static boolean isSolved(Case actual, SolverScheduleSolution sol){
		Map<String, Double> actualTimes = ((SolverTimesFeature) actual.getFeature(Parser.SOLVER_TIMES_FEATURE)).getValue();
		HashMap<String, Integer> scheduleTimes = sol.getSolverAndTimes();
		String[] solverNames = sol.getSolverNames();
		for(int x=0;x<solverNames.length;x++){
			if(actualTimes.get(solverNames[x]).doubleValue()<scheduleTimes.get(solverNames[x]).intValue()){
				return true;
			}
		}
		return false;
	}
	
	public static void main(String[] args){
		//String testDir = "CBR Data/Parser Output Data/named_casebase";
		String testDir = "/home/edom/casebase2006";
		//Casebase casebase = Parser.parseNamedFile(testDir);
		Casebase casebase = Parser.parseNamedFile(testDir);
		//NormaliseCasebase.normaliseCasebase(casebase, NormaliseCasebase.getMinMax(casebase));
//		EvaluateScheduler.runHoldOneOutEvaluation(casebase , casebase.size()-1);
		EvaluateScheduler.runHoldOneOutEvaluation(casebase , 10);
//		EvaluateScheduler.run_static_schecule(casebase);
		System.out.println("c 10 nearest neighbours");
	}

}
