package features;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;


public class SolverTimesFeature extends Feature{

	private Map<String, Double> times;
	
	public SolverTimesFeature(String featureName, Map<String, Double> times){
		super(featureName);
		this.times = times;
	}
	
	protected SolverTimesFeature(String featureName) {
		super(featureName);
	}

	@Override
	public Object clone(){
		Map<String, Double> newTimes = new HashMap<String, Double>();
		Iterator<String> names = times.keySet().iterator();
		while(names.hasNext()){
			String solverName = names.next();
			newTimes.put(name, new Double(times.get(solverName).doubleValue()));
		}
		return new SolverTimesFeature(this.getName(), newTimes);
	}

	@Override
	public boolean equals(Object obj) {
		return false;
	}

	@Override
	public Map<String, Double> getValue() {
		return times;
	}

	@SuppressWarnings("unchecked")
	@Override
	public void setValue(Object value) throws BadFeatureValueException {
		if(value instanceof HashMap)
			times = (HashMap<String,Double>)value;
	}
	
	

}
