package similarity;

import java.util.Iterator;

import cases.Case;
import features.DoubleFeature;
import features.Feature;


public class ArrayEuclideanSimilarity implements SimilarityMeasure{

	public double getSimilarity(Feature featOne, Feature featTwo) {
			if(featOne instanceof DoubleFeature && featTwo instanceof DoubleFeature){
				return (Double)featOne.getValue() - (Double)featTwo.getValue();
			}
			return 1;
	}
	
	public double getSimilarity(Case one, Case two){
		double sim = 0;
		int index = 0;
		String f_name;
		Iterator<String> names = one.featureNames();
		while(names.hasNext()){
			f_name = names.next();
			if(!f_name.equals("Times")){
				double diff = getSimilarity(one.getFeature(f_name), two.getFeature(f_name));
				//sim += getSimilarity(one.getFeature(f_name), two.getFeature(f_name));
				sim+= diff*diff;
				index++;
			}
		}
		//return Math.sqrt((sim*sim)/index);
		return Math.sqrt(sim);
	}


}
